osg::OcclusionQueryNode Class Reference

`#include <OcclusionQueryNode>`

Inheritance diagram for osg::OcclusionQueryNode:

## Public Member Functions

| OcclusionQueryNode ()
| OcclusionQueryNode (const OcclusionQueryNode &oqn, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Node (osg, OcclusionQueryNode)
virtual osg::BoundingSphere | computeBound () const
virtual void | releaseGLObjects (osg::State *state=0) const
void | setQueriesEnabled (bool enable=true)
bool | getQueriesEnabled () const
void | setVisibilityThreshold (unsigned int pixels)
unsigned int | getVisibilityThreshold () const
void | setQueryFrameCount (unsigned int frames)
unsigned int | getQueryFrameCount () const
void | resetQueries ()
void | setDebugDisplay (bool enable)
bool | getDebugDisplay () const
void | setQueryStateSet (osg::StateSet *ss)
osg::StateSet * | getQueryStateSet ()
const osg::StateSet * | getQueryStateSet () const
void | setQueryGeometry (osg::QueryGeometry *geom)
const osg::QueryGeometry * | getQueryGeometry () const
void | setDebugStateSet (osg::StateSet *ss)
osg::StateSet * | getDebugStateSet ()
const osg::StateSet * | getDebugStateSet () const
bool | getPassed () const
virtual bool | getPassed (const osg::Camera *camera, osg::NodeVisitor &nv)
void | traverseQuery (const osg::Camera *camera, osg::NodeVisitor &nv)
void | traverseDebug (osg::NodeVisitor &nv)
Public Member Functions inherited from osg::Group
| Group ()
| Group (const Group &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, Group)
virtual Group * | asGroup ()
virtual const Group * | asGroup () const
virtual void | traverse (NodeVisitor &nv)
virtual bool | addChild (Node *child)
template<class T>
bool | addChild (const ref_ptr< T > &child)
virtual bool | insertChild (unsigned int index, Node *child)
template<class T>
bool | insertChild (unsigned int index, const ref_ptr< T > &child)
virtual bool | removeChild (Node *child)
template<class T>
bool | removeChild (const ref_ptr< T > &child)
bool | removeChild (unsigned int pos, unsigned int numChildrenToRemove=1)
virtual bool | removeChildren (unsigned int pos, unsigned int numChildrenToRemove)
virtual bool | replaceChild (Node *origChild, Node *newChild)
template<class T, class R>
bool | replaceChild (const ref_ptr< T > &origChild, const ref_ptr< R > &newChild)
virtual unsigned int | getNumChildren () const
virtual bool | setChild (unsigned int i, Node *node)
Node * | getChild (unsigned int i)
const Node * | getChild (unsigned int i) const
bool | containsNode (const Node *node) const
template<class T>
bool | containsNode (const ref_ptr< T > &node) const
unsigned int | getChildIndex (const Node *node) const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
Public Member Functions inherited from osg::Node
| Node ()
| Node (const Node &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const
virtual Object * | clone (const CopyOp &copyop) const
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Geometry * | asGeometry ()
virtual const Geometry * | asGeometry () const
virtual Transform * | asTransform ()
virtual const Transform * | asTransform () const
virtual Switch * | asSwitch ()
virtual const Switch * | asSwitch () const
virtual Geode * | asGeode ()
virtual const Geode * | asGeode () const
virtual osgTerrain::Terrain * | asTerrain ()
virtual const osgTerrain::Terrain * | asTerrain () const
virtual void | accept (NodeVisitor &nv)
virtual void | ascend (NodeVisitor &nv)
const ParentList & | getParents () const
ParentList | getParents ()
Group * | getParent (unsigned int i)
const Group * | getParent (unsigned int i) const
unsigned int | getNumParents () const
NodePathList | getParentalNodePaths (osg::Node *haltTraversalAtNode=0) const
MatrixList | getWorldMatrices (const osg::Node *haltTraversalAtNode=0) const
void | setUpdateCallback (Callback *nc)
template<class T>
void | setUpdateCallback (const ref_ptr< T > &nc)
Callback * | getUpdateCallback ()
const Callback * | getUpdateCallback () const
void | addUpdateCallback (Callback *nc)
template<class T>
void | addUpdateCallback (const ref_ptr< T > &nc)
void | removeUpdateCallback (Callback *nc)
template<class T>
void | removeUpdateCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringUpdateTraversal () const
void | setEventCallback (Callback *nc)
template<class T>
void | setEventCallback (const ref_ptr< T > &nc)
Callback * | getEventCallback ()
const Callback * | getEventCallback () const
void | addEventCallback (Callback *nc)
template<class T>
void | addEventCallback (const ref_ptr< T > &nc)
void | removeEventCallback (Callback *nc)
template<class T>
void | removeEventCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringEventTraversal () const
void | setCullCallback (Callback *nc)
template<class T>
void | setCullCallback (const ref_ptr< T > &nc)
Callback * | getCullCallback ()
const Callback * | getCullCallback () const
void | addCullCallback (Callback *nc)
template<class T>
void | addCullCallback (const ref_ptr< T > &nc)
void | removeCullCallback (Callback *nc)
template<class T>
void | removeCullCallback (const ref_ptr< T > &nc)
void | setCullingActive (bool active)
bool | getCullingActive () const
unsigned int | getNumChildrenWithCullingDisabled () const
bool | isCullingActive () const
unsigned int | getNumChildrenWithOccluderNodes () const
bool | containsOccluderNodes () const
void | setNodeMask (NodeMask nm)
NodeMask | getNodeMask () const
void | setStateSet (osg::StateSet *stateset)
template<class T>
void | setStateSet (const osg::ref_ptr< T > &stateset)
osg::StateSet * | getOrCreateStateSet ()
osg::StateSet * | getStateSet ()
const osg::StateSet * | getStateSet () const
void | setDescriptions (const DescriptionList &descriptions)
DescriptionList & | getDescriptions ()
const DescriptionList & | getDescriptions () const
const std::string & | getDescription (unsigned int i) const
std::string & | getDescription (unsigned int i)
unsigned int | getNumDescriptions () const
void | addDescription (const std::string &desc)
void | setInitialBound (const osg::BoundingSphere &bsphere)
const BoundingSphere & | getInitialBound () const
void | dirtyBound ()
const BoundingSphere & | getBound () const
void | setComputeBoundingSphereCallback (ComputeBoundingSphereCallback *callback)
template<class T>
void | setComputeBoundingSphereCallback (const ref_ptr< T > &callback)
ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback ()
const ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Static Public Member Functions

static void | flushDeletedQueryObjects (unsigned int contextID, double currentTime, double &availableTime)
static void | discardDeletedQueryObjects (unsigned int contextID)
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Protected Types

enum | QueryGeometryState { INVALID , VALID , USER_DEFINED }
typedef std::map< const osg::Camera *, unsigned int > | FrameCountMap

## Protected Member Functions

virtual | ~OcclusionQueryNode ()
virtual void | createSupportNodes ()
bool | isQueryGeometryValid () const
void | setQueryGeometryInternal (osg::QueryGeometry *queryGeom, osg::Geometry *debugQueryGeom, QueryGeometryState state)
void | updateDefaultQueryGeometry ()
Protected Member Functions inherited from osg::Group
virtual | ~Group ()
virtual void | childRemoved (unsigned int, unsigned int)
virtual void | childInserted (unsigned int)
Protected Member Functions inherited from osg::Node
virtual | ~Node ()
void | addParent (osg::Group *parent)
void | removeParent (osg::Group *parent)
void | setNumChildrenRequiringUpdateTraversal (unsigned int num)
void | setNumChildrenRequiringEventTraversal (unsigned int num)
void | setNumChildrenWithCullingDisabled (unsigned int num)
void | setNumChildrenWithOccluderNodes (unsigned int num)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

osg::ref_ptr< osg::Geode > | _queryGeode
osg::ref_ptr< osg::Geode > | _debugGeode
bool | _enabled
QueryGeometryState | _queryGeometryState
FrameCountMap | _frameCountMap
OpenThreads::Mutex | _frameCountMutex
bool | _passed
unsigned int | _visThreshold
unsigned int | _queryFrameCount
bool | _debugBB
OpenThreads::Mutex | _computeBoundMutex
Protected Attributes inherited from osg::Group
NodeList | _children
Protected Attributes inherited from osg::Node
BoundingSphere | _initialBound
ref_ptr< ComputeBoundingSphereCallback > | _computeBoundCallback
BoundingSphere | _boundingSphere
bool | _boundingSphereComputed
ParentList | _parents
ref_ptr< Callback > | _updateCallback
unsigned int | _numChildrenRequiringUpdateTraversal
ref_ptr< Callback > | _eventCallback
unsigned int | _numChildrenRequiringEventTraversal
ref_ptr< Callback > | _cullCallback
bool | _cullingActive
unsigned int | _numChildrenWithCullingDisabled
unsigned int | _numChildrenWithOccluderNodes
NodeMask | _nodeMask
ref_ptr< StateSet > | _stateset
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Public Types inherited from osg::Node
typedef std::vector< Group * > | ParentList
typedef unsigned int | NodeMask
typedef std::vector< std::string > | DescriptionList
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Member Typedef Documentation

## FrameCountMap

typedef std::map< const osg::Camera*, unsigned int > osg::OcclusionQueryNode::FrameCountMap

protected

## Member Enumeration Documentation

## QueryGeometryState

enum osg::OcclusionQueryNode::QueryGeometryState

protected

Enumerator
INVALID |
VALID |
USER_DEFINED |

## Constructor & Destructor Documentation

## OcclusionQueryNode() [1/2]

osg::OcclusionQueryNode::OcclusionQueryNode | ( |  | ) |

Referenced by META_Node(), and OcclusionQueryNode().

## OcclusionQueryNode() [2/2]

osg::OcclusionQueryNode::OcclusionQueryNode | ( | const OcclusionQueryNode & | oqn,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

References OcclusionQueryNode(), and osg::CopyOp::SHALLOW_COPY.

## ~OcclusionQueryNode()

virtual osg::OcclusionQueryNode::~OcclusionQueryNode | ( |  | ) |

protected virtual

## Member Function Documentation

## computeBound()

virtual osg::BoundingSphere osg::OcclusionQueryNode::computeBound | ( |  | ) | const

virtual

Compute the bounding sphere around Node's geometry or children. This method is automatically called by getBound() when the bounding sphere has been marked dirty via dirtyBound().

Reimplemented from osg::Group.

## createSupportNodes()

virtual void osg::OcclusionQueryNode::createSupportNodes | ( |  | ) |

protected virtual

## discardDeletedQueryObjects()

void osg::OcclusionQueryNode::discardDeletedQueryObjects | ( | unsigned int | contextID | ) |

static

## flushDeletedQueryObjects()

void osg::OcclusionQueryNode::flushDeletedQueryObjects | ( | unsigned int | contextID,
|  | double | currentTime,
|  | double & | availableTime )

static

## getDebugDisplay()

bool osg::OcclusionQueryNode::getDebugDisplay | ( |  | ) | const

## getDebugStateSet() [1/2]

osg::StateSet * osg::OcclusionQueryNode::getDebugStateSet | ( |  | ) |

## getDebugStateSet() [2/2]

const osg::StateSet * osg::OcclusionQueryNode::getDebugStateSet | ( |  | ) | const

## getPassed() [1/2]

bool osg::OcclusionQueryNode::getPassed | ( |  | ) | const

## getPassed() [2/2]

virtual bool osg::OcclusionQueryNode::getPassed | ( | const osg::Camera * | camera,
|  | osg::NodeVisitor & | nv )

virtual

## getQueriesEnabled()

bool osg::OcclusionQueryNode::getQueriesEnabled | ( |  | ) | const

inline

References _enabled.

## getQueryFrameCount()

unsigned int osg::OcclusionQueryNode::getQueryFrameCount | ( |  | ) | const

inline

References _queryFrameCount.

## getQueryGeometry()

const osg::QueryGeometry * osg::OcclusionQueryNode::getQueryGeometry | ( |  | ) | const

## getQueryStateSet() [1/2]

osg::StateSet * osg::OcclusionQueryNode::getQueryStateSet | ( |  | ) |

## getQueryStateSet() [2/2]

const osg::StateSet * osg::OcclusionQueryNode::getQueryStateSet | ( |  | ) | const

## getVisibilityThreshold()

unsigned int osg::OcclusionQueryNode::getVisibilityThreshold | ( |  | ) | const

inline

References _visThreshold.

## isQueryGeometryValid()

bool osg::OcclusionQueryNode::isQueryGeometryValid | ( |  | ) | const

inline protected

References _queryGeometryState, and INVALID.

## META_Node()

osg::OcclusionQueryNode::META_Node | ( | osg | ,
|  | OcclusionQueryNode | )

References OcclusionQueryNode().

## releaseGLObjects()

virtual void osg::OcclusionQueryNode::releaseGLObjects | ( | osg::State * | = 0 | ) | const

virtual

If State is non-zero, this function releases any associated OpenGL objects for the specified graphics context. Otherwise, releases OpenGL objects for all graphics contexts.

Reimplemented from osg::Group.

## resetQueries()

void osg::OcclusionQueryNode::resetQueries | ( |  | ) |

## setDebugDisplay()

void osg::OcclusionQueryNode::setDebugDisplay | ( | bool | enable | ) |

## setDebugStateSet()

void osg::OcclusionQueryNode::setDebugStateSet | ( | osg::StateSet * | ss | ) |

## setQueriesEnabled()

void osg::OcclusionQueryNode::setQueriesEnabled | ( | bool | enable = true | ) |

## setQueryFrameCount()

void osg::OcclusionQueryNode::setQueryFrameCount | ( | unsigned int | frames | ) |

inline

References _queryFrameCount.

## setQueryGeometry()

void osg::OcclusionQueryNode::setQueryGeometry | ( | osg::QueryGeometry * | geom | ) |

## setQueryGeometryInternal()

void osg::OcclusionQueryNode::setQueryGeometryInternal | ( | osg::QueryGeometry * | queryGeom,
|  | osg::Geometry * | debugQueryGeom,
|  | QueryGeometryState | state )

protected

## setQueryStateSet()

void osg::OcclusionQueryNode::setQueryStateSet | ( | osg::StateSet * | ss | ) |

## setVisibilityThreshold()

void osg::OcclusionQueryNode::setVisibilityThreshold | ( | unsigned int | pixels | ) |

inline

References _visThreshold.

## traverseDebug()

void osg::OcclusionQueryNode::traverseDebug | ( | osg::NodeVisitor & | nv | ) |

## traverseQuery()

void osg::OcclusionQueryNode::traverseQuery | ( | const osg::Camera * | camera,
|  | osg::NodeVisitor & | nv )

## updateDefaultQueryGeometry()

void osg::OcclusionQueryNode::updateDefaultQueryGeometry | ( |  | ) |

protected

## Member Data Documentation

## _computeBoundMutex

OpenThreads::Mutex osg::OcclusionQueryNode::_computeBoundMutex

mutable protected

## _debugBB

bool osg::OcclusionQueryNode::_debugBB

protected

## _debugGeode

osg::ref_ptr< osg::Geode > osg::OcclusionQueryNode::_debugGeode

protected

## _enabled

bool osg::OcclusionQueryNode::_enabled

protected

Referenced by getQueriesEnabled().

## _frameCountMap

FrameCountMap osg::OcclusionQueryNode::_frameCountMap

protected

## _frameCountMutex

OpenThreads::Mutex osg::OcclusionQueryNode::_frameCountMutex

mutable protected

## _passed

bool osg::OcclusionQueryNode::_passed

protected

## _queryFrameCount

unsigned int osg::OcclusionQueryNode::_queryFrameCount

protected

Referenced by getQueryFrameCount(), and setQueryFrameCount().

## _queryGeode

osg::ref_ptr< osg::Geode > osg::OcclusionQueryNode::_queryGeode

protected

## _queryGeometryState

QueryGeometryState osg::OcclusionQueryNode::_queryGeometryState

mutable protected

Referenced by isQueryGeometryValid().

## _visThreshold

unsigned int osg::OcclusionQueryNode::_visThreshold

protected

Referenced by getVisibilityThreshold(), and setVisibilityThreshold().

The documentation for this class was generated from the following file:

- OcclusionQueryNode